/***************************************************************************
 *   Copyright (C) 2004-2008 by Pere Constans
 *   constans@molspaces.com
 *   cb2Bib version 1.0.4. Licensed under the GNU GPL version 3.
 *   See the LICENSE file that comes with this distribution.
 ***************************************************************************/
#ifndef AUTHORSTRING_H
#define AUTHORSTRING_H

#include <QRegExp>
#include <QString>
#include <QStringList>

/**
    @author Pere Constans
*/
class authorString : public QString
{
public:
    authorString(QString Alist, bool full_form = 0);
    ~authorString();

    inline const QString bib() const
    {
        return(authors);
    }


private:
    bool authorsInUC;
    bool containLowerCaseLetter(QString);
    bool containUpperCaseLetter(QString);
    bool fullForm;
    bool RevName(QString);
    const QString capitalize(const QString& name);
    const QString processFirstMiddle(const QString& first_middle);
    QString authors;
    QString toBib(QString);

};

#endif
