FORMS += c2bConfigure.ui \
         c2bConfigureFR.ui \
         c2bEditor.ui \
         c2bExportDialog.ui \
         c2bLogWidget.ui \
         c2bPdfImport.ui \
         c2bRLWebSearchSettings.ui \
         c2bReferenceList.ui \
         c2bSaveRegExp.ui \
         c2bSearchInFiles.ui \
         c2bSearchInFilesPattern.ui \
         c2bSearchInFilesPatternEdit.ui \
         cb2Bib.ui \
         findDialog.ui
RESOURCES += cb2bib.qrc 
HEADERS += authorString.h \
           bibParser.h \
           bookmarkPlugin.h \
           c2b.h \
           c2bApproximatePattern.h \
           c2bBibHighlighter.h \
           c2bBibParser.h \
           c2bBibPreparser.h \
           c2bBibPreparserLog.h \
           c2bBibSearcher.h \
           c2bBibSearcherCache.h \
           c2bCiteIDLineEdit.h \
           c2bCiteIDMaker.h \
           c2bClipEdit.h \
           c2bClipboard.h \
           c2bColors.h \
           c2bComboBox.h \
           c2bConfigure.h \
           c2bConfigureFR.h \
           c2bEditor.h \
           c2bExport.h \
           c2bExportDialog.h \
           c2bFileDialog.h \
           c2bHeuristicBibParser.h \
           c2bHighlighter.h \
           c2bLineEdit.h \
           c2bMetaPreparser.h \
           c2bNetwork.h \
           c2bNetworkQuery.h \
           c2bNetworkQueryInfo.h \
           c2bPdfImport.h \
           c2bPostprocess.h \
           c2bPreprocess.h \
           c2bREHighlighter.h \
           c2bRLWebSearchSettings.h \
           c2bReferenceList.h \
           c2bSaveRegExp.h \
           c2bSearchInFiles.h \
           c2bSearchInFilesPattern.h \
           c2bSearchPattern.h \
           c2bSettings.h \
           c2bTextBrowser.h \
           c2bTextEdit.h \
           c2bUpdateMetadata.h \
           c2bUtils.h \
           c2bWordPattern.h \
           cb2Bib.h \
           cb2Bib_par.h \
           clipboardPoll.h \
           compositePattern.h \
           findDialog.h \
           journalDB.h \
           monthDB.h
SOURCES += authorString.cpp \
           bibParser.cpp \
           bookmarkPlugin.cpp \
           c2b.cpp \
           c2bApproximatePattern.cpp \
           c2bBibHighlighter.cpp \
           c2bBibParser.cpp \
           c2bBibPreparser.cpp \
           c2bBibPreparserLog.cpp \
           c2bBibSearcher.cpp \
           c2bBibSearcherCache.cpp \
           c2bCiteIDLineEdit.cpp \
           c2bCiteIDMaker.cpp \
           c2bClipEdit.cpp \
           c2bClipboard.cpp \
           c2bColors.cpp \
           c2bComboBox.cpp \
           c2bConfigure.cpp \
           c2bConfigureFR.cpp \
           c2bEditor.cpp \
           c2bExport.cpp \
           c2bExportDialog.cpp \
           c2bFileDialog.cpp \
           c2bHeuristicBibParser.cpp \
           c2bHighlighter.cpp \
           c2bLineEdit.cpp \
           c2bMetaPreparser.cpp \
           c2bNetwork.cpp \
           c2bNetworkQuery.cpp \
           c2bNetworkQueryInfo.cpp \
           c2bPdfImport.cpp \
           c2bPostprocess.cpp \
           c2bPreprocess.cpp \
           c2bREHighlighter.cpp \
           c2bRLWebSearchSettings.cpp \
           c2bReferenceList.cpp \
           c2bSaveRegExp.cpp \
           c2bSearchInFiles.cpp \
           c2bSearchInFilesPattern.cpp \
           c2bSearchPattern.cpp \
           c2bSettings.cpp \
           c2bTextBrowser.cpp \
           c2bTextEdit.cpp \
           c2bUpdateMetadata.cpp \
           c2bUtils.cpp \
           c2bWordPattern.cpp \
           cb2Bib.cpp \
           clipboardPoll.cpp \
           compositePattern.cpp \
           findDialog.cpp \
           journalDB.cpp \
           main.cpp \
           monthDB.cpp
TEMPLATE = app
QT += network xml
CONFIG +=
TARGET = cb2bib
DESTDIR = ../bin
DEPENDPATH += .
INCLUDEPATH += .
QMAKE_CXXFLAGS_DEBUG += -DCB2BIB_DEBUG
DEFINES += CB_POLL
disable_cbpoll {
    message(Building without clipboardPoll.)
    HEADERS -= clipboardPoll.h
    SOURCES -= clipboardPoll.cpp
    DEFINES -= CB_POLL
}
unix {
    INSTALLS += cb2bibdata \
    icons \
    desktop \
    target \
    script
    target.path = /usr/bin
    script.files += ../c2btools/dl_cb2bib
    script.path = /usr/bin
    desktop.files += ../cb2bib.desktop \
    ../dl_cb2bib.desktop
    desktop.path = /usr/share/applications
    icons.files += ../src/icons/cb2bib.png
    icons.path = /usr/share/pixmaps
    cb2bibdata.files += ../AUTHORS \
    ../COPYRIGHT \
    ../LICENSE \
    ../data \
    ../c2btools \
    ../testPDFImport
    cb2bibdata.path = /usr/share/cb2bib
}
win32 {
    HEADERS -= clipboardPoll.h
    SOURCES -= clipboardPoll.cpp
    DEFINES -= CB_POLL
    RC_FILE = ../cb2bib.rc
}
macx {
    HEADERS -= clipboardPoll.h
    SOURCES -= clipboardPoll.cpp
    DEFINES -= CB_POLL
    ICON = ../src/icons/cb2bib.icns
    INSTALLS += target script cb2bibdata
    target.path = /Applications
    script.files += ../c2btools/dl_cb2bib
    script.path = /Applications
    cb2bibdata.files += ../AUTHORS \
    ../COPYRIGHT \
    ../LICENSE \
    ../data \
    ../c2btools \
    ../testPDFImport
    cb2bibdata.path = Contents/Resources
    QMAKE_BUNDLE_DATA += script cb2bibdata
#   Set this directory if third party tools, like pdftotext are packaged
#   INSTALLS += externtools
#   externtools.files +=
#   externtools.path = c2bExternTools
#   Set Library data
#   QMAKE_BUNDLE_DATA += externtools
}
